#define PAM_SM_AUTH
#include <security/pam_modules.h>
#include <security/pam_appl.h>
#include <security/pam_ext.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <time.h>

PAM_EXTERN int pam_sm_authenticate(pam_handle_t *pamh, int flags, int argc, const char **argv) {
	int ret;
	char *mtmp = NULL;
	int a = 0;
	int b = 0;
	int c = 0;
	int userguess;
	int correctvalue = 0;

	srand(time(NULL));
	while(!((correctvalue > 10) && (correctvalue < 1000))) {
		a = 1+(30.0*rand()/(RAND_MAX+1.0));
		b = 1+(30.0*rand()/(RAND_MAX+1.0));
		c = 99.0*rand()/(RAND_MAX+1.0);
		correctvalue = a*b + c;
	}

	ret = pam_prompt(pamh, PAM_PROMPT_ECHO_ON, &mtmp, "Calculate: %d * %d + %d\n", a, b, c);
	if(ret == PAM_BUF_ERR) {
		pam_syslog(pamh, LOG_ERR, "Memory buffer error in pam_info");
		return PAM_AUTHINFO_UNAVAIL;
	} else if (ret == PAM_CONV_ERR) {
		pam_syslog(pamh, LOG_ERR, "Conversation failure in pam_info");
		return PAM_AUTHINFO_UNAVAIL;
	} else if (ret == PAM_SYSTEM_ERR) {
		pam_syslog(pamh, LOG_ERR, "System error in pam_info");
		return PAM_AUTHINFO_UNAVAIL;
	} else if (ret != PAM_SUCCESS) {
		pam_syslog(pamh, LOG_ERR, "Unknown error in pam_info");
		return PAM_AUTHINFO_UNAVAIL;
	}

	userguess = atoi(mtmp);
	if(userguess == correctvalue) {
		return PAM_SUCCESS;
	} else {
		return PAM_AUTH_ERR;
	}
}

PAM_EXTERN int pam_sm_close_session(pam_handle_t *pamh, int flags, int argc, const char **argv) {
	return PAM_IGNORE;
}

PAM_EXTERN int pam_sm_setcred(pam_handle_t *pamh, int flags, int argc, const char **argv) {
	return PAM_CRED_UNAVAIL;
}
